<?php

/**
 * Vvveb
 *
 * Copyright (C) 2022  Ziadin Givan
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 */

namespace Vvveb\Plugins\GraphQL\Controller;

use function Vvveb\__;
use Vvveb\Controller\Base;
use function Vvveb\reconstructJson;
use Vvveb\System\CacheManager;
use Vvveb\System\Core\View;

class Settings extends Base {
	function save() {
		//$validator = new Validator(['plugins.gravatar.settings']);
		$settings  = $this->request->post['settings'] ?? false;
		$errors    = [];

		if ($settings /*&&
			($errors = $validator->validate($settings)) === true*/) {
			//$settings              = $validator->filter($settings);
			$results               = \Vvveb\setMultiSetting('graphql', $settings);
			//CacheManager::delete('component');
			CacheManager::delete();
			$this->view->success[] = __('Settings saved!');
		} else {
			$this->view->errors = $errors;
		}

		$this->index();
	}

	function index() {
		if (! GRAPHQL) {
			$this->view->errors[] = sprintf(__('%s not enabled, edit /env.php to enable'), 'GraphQL');
		}
	}

	function renderJson() {
		$htmlView  = new View();
		//$htmlView  = clone $this->view;
		$htmlView->setTheme();
		$htmlView->set(['seo' => []]);
		$htmlView->template('plugins/graphql/openapi.json');
		$xml   = $htmlView->render(true, false, true);

		if ($xml) {
			//echo 'XML';var_dump($xml);
			$sxml  = \simplexml_load_string($xml, null, LIBXML_NOCDATA | LIBXML_DTDATTR);
			//echo 'sxml';var_dump($sxml);
			$array = reconstructJson($sxml, true);

			return $array;
			$json  = json_encode($array, JSON_THROW_ON_ERROR | JSON_PRETTY_PRINT);
			echo $json;
		}
	}

	function api() {
		$json = $this->renderJson();

		//$json = file_get_contents(DIR_PLUGINS . 'graphql/graphql.json');

		$this->response->setType('json');
		$this->response->output($json);
		//echo $json;

		die();
	}
}
